<template>
  <section>
    <div class="progress-wrapper">
      <value
        class="progress-completed"
        :value="closedIssues / target"
        :max="600"
      />
      <value
        class="progress-assigned"
        :value="inDevIssues / target"
        :max="600"
      />
      <value
        class="progress-ready"
        :value="inValidationIssues / target"
        :max="600"
      />
      <value
        class="progress-unknown"
        :value="unknownIssues / target"
        :max="600"
      />
      <value class="progress-open" :value="openIssues / target" :max="600" />
      <value
        class="progress-blocked"
        :value="blockedIssues / target"
        :max="600"
      />
      <div class="progress-target" :style="{ left: 600 }" />
    </div>
    <table>
      <tbody>
        <tr>
          <td></td>
          <td class="text-align-right">
            <strong>{{ target }}</strong>
          </td>
          <td>
            Target: completed SUS severity::1 and severity::2 issues this
            quarter
          </td>
        </tr>
        <tr class="border-top">
          <td></td>
          <td class="text-align-right">{{ closedIssues + inDevIssues }}</td>
          <td>SUS issues, that are done, in development or in validation:</td>
        </tr>
        <tr>
          <td><span class="progress-completed legend"></span></td>
          <td class="text-align-right">{{ closedIssues }}</td>
          <td>closed issues</td>
        </tr>
        <tr>
          <td><span class="progress-assigned legend"></span></td>
          <td class="text-align-right">{{ inDevIssues }}</td>
          <td>in development</td>
        </tr>
        <tr class="border-bottom">
          <td><span class="progress-ready legend"></span></td>
          <td class="text-align-right">{{ inValidationIssues }}</td>
          <td>in validation</td>
        </tr>
        <tr v-if="unknownIssues > 0">
          <td><span class="progress-unknown legend"></span></td>
          <td class="text-align-right">{{ unknownIssues }}</td>
          <td>open issues in unknown states {{ unknownStates }}</td>
        </tr>
        <tr>
          <td><span class="progress-open legend"></span></td>
          <td class="text-align-right">{{ openIssues }}</td>
          <td>open issues <i>without</i> workflow labels</td>
        </tr>
        <tr>
          <td><span class="progress-blocked legend"></span></td>
          <td class="text-align-right">{{ blockedIssues }}</td>
          <td>blocked issues</td>
        </tr>
        <tr v-if="coordinationIssue" class="border-top">
          <td><span class="progress-unknown legend"></span></td>
          <td class="text-align-right">{{ uncoordinatedIssues }}</td>
          <td>
            total issues that are <strong>not tracked</strong> in
            <a :href="coordinationIssue">our coordination issue</a>
          </td>
        </tr>
      </tbody>
    </table>
  </section>
</template>
<script>
import Value from "./Value.vue";
import { ISSUE_STATES_SUS } from "../../lib/constants";

export default {
  name: "overall-stats",
  components: { Value },
  props: {
    target: {},
    issues: {},
    coordinationIssue: {},
  },
  computed: {
    total() {
      return this.issues
        .map((x) => x.issueStatus)
        .reduce((acc, curr) => {
          acc[curr] ||= 0;
          acc[curr] += 1;
          return acc;
        }, {});
    },
    unknownStates() {
      const unknown = this.issues.flatMap((x) =>
        x.issueStatus === ISSUE_STATES_SUS.UNKNOWN
          ? x.labels.find((x) => x.startsWith("workflow::"))
          : []
      );

      return [...new Set(unknown)];
    },
    closedIssues() {
      return this.total[ISSUE_STATES_SUS.CLOSED] || 0;
    },
    openIssues() {
      return this.total[ISSUE_STATES_SUS.OPEN] || 0;
    },
    inDevIssues() {
      return this.total[ISSUE_STATES_SUS.IN_DEVELOPMENT] || 0;
    },
    inValidationIssues() {
      return this.total[ISSUE_STATES_SUS.IN_VALIDATION] || 0;
    },
    unknownIssues() {
      return this.total[ISSUE_STATES_SUS.UNKNOWN] || 0;
    },
    blockedIssues() {
      return this.total[ISSUE_STATES_SUS.BLOCKED] || 0;
    },
    uncoordinatedIssues() {
      return this.issues.filter((x) => !x.trackedInPlanningIssue).length;
    },
  },
};
</script>
<style scoped>
td {
  line-height: 24px;
  padding: 4px 2px;
}

.legend {
  height: 24px;
  width: 24px;
  display: inline-block;
}

.border-top td {
  border-top: 1px solid black;
}

.border-bottom td {
  border-bottom: 1px solid black;
}

.text-align-right {
  text-align: right;
}
</style>
